/*
 * This file is part of hp-utils.
 * Copyright (C) 2008 Michael Denk
 *
 * hp-utils is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * hp-utils is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with hp-utils; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Author: Michael Denk
 */

#ifndef DEVICE_H_
#define DEVICE_H_ 1

#include <stdlib.h>

#include "pml.h"

struct model_data {
	int io_mfp_mode;
	int io_mode;
	int clean_type;
	int status_type;
	int fax_type;
};

struct device {
	char *uri;
	char *model;
	char *id;
	/* parsed from uri; char *foo is a pointer on uri */
	char *back_end;
	int is_hp;
	char *bus;
	char *serial;
	char *dev_file;
	char *host;
	int port;
	/* end of parsed from uri */
	struct model_data *md;
	struct device *next;
};

struct device * device_probe_devices();
struct device * device_get_device(const char *uri);
int device_query(struct device *d);
void device_free(struct device *d);
int device_printData(struct device *d, const char *data, size_t len);
int device_setPML(struct device *d, struct pml *pml, const char *value, size_t len);
int device_getPML(struct device *d, struct pml *pml, char *out, size_t *size);

#endif
