/*
 * This file is part of hp-utils.
 * Copyright (C) 2008 Michael Denk
 *
 * hp-utils is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * hp-utils is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with hp-utils; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Author: Michael Denk
 */

#include <string.h>
#include <hpmud.h>

#include "hpmuderr.h"

static char hpmuderrbuf[64];

const char * hpmudstrerr(enum HPMUD_RESULT res)
{
	switch (res) {
		case HPMUD_R_OK:
			strcpy(hpmuderrbuf, "");
			break;
		case HPMUD_R_INVALID_DEVICE:
			strcpy(hpmuderrbuf, "invalid device");
			break;
		case HPMUD_R_INVALID_DESCRIPTOR:
			strcpy(hpmuderrbuf, "invalid descriptor");
			break;
		case HPMUD_R_INVALID_URI:
			strcpy(hpmuderrbuf, "invalid URI");
			break;
		case HPMUD_R_INVALID_LENGTH:
			strcpy(hpmuderrbuf, "invalid length");
			break;
		case HPMUD_R_IO_ERROR:
			strcpy(hpmuderrbuf, "I/O error");
			break;
		case HPMUD_R_DEVICE_BUSY:
			strcpy(hpmuderrbuf, "device busy");
			break;
		case HPMUD_R_INVALID_SN:
			strcpy(hpmuderrbuf, "invalid serial number");
			break;
		case HPMUD_R_INVALID_CHANNEL_ID:
			strcpy(hpmuderrbuf, "invalid channel id");
			break;
		case HPMUD_R_INVALID_STATE:
			strcpy(hpmuderrbuf, "invalid state");
			break;
		case HPMUD_R_INVALID_DEVICE_OPEN:
			strcpy(hpmuderrbuf, "invalid device open");
			break;
		case HPMUD_R_INVALID_DEVICE_NODE:
			strcpy(hpmuderrbuf, "invalid device node");
			break;
		case HPMUD_R_INVALID_IP:
			strcpy(hpmuderrbuf, "invalid IP address");
			break;
		case HPMUD_R_INVALID_IP_PORT:
			strcpy(hpmuderrbuf, "invalid IP port");
			break;
		case HPMUD_R_INVALID_TIMEOUT:
			strcpy(hpmuderrbuf, "invalid timeout");
			break;
		case HPMUD_R_DATFILE_ERROR:
			strcpy(hpmuderrbuf, "file error models.dat");
			break;
		case HPMUD_R_IO_TIMEOUT:
			strcpy(hpmuderrbuf, "I/O timeout");
			break;
		default:
			strcpy(hpmuderrbuf, "unknown error");
	}
	return hpmuderrbuf;
}
