/*
 * This file is part of hp-utils.
 * Copyright (C) 2008 Michael Denk
 *
 * hp-utils is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * hp-utils is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with hp-utils; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Author: Michael Denk
 */

#include <stdio.h>
#include <string.h>

#include "pcl.h"
#include "util.h"

size_t pcl_buildEmbeddedPML(char *buf, size_t size, const char *pml, size_t len)
{
	size_t s;

	s = snprintf(buf, size, "%s%s%s", UEL, PJL_ENTER_LANG, RESET);
	memcpy(buf + s, pml, MIN(size - s, len));
	s += MIN(size - s, len);
	s += snprintf(buf + s, size - s, "%s%s", RESET, UEL);
	return s;
}

size_t pcl_buildEmbeddedPML2(char *buf, size_t size, const char *pml, size_t len)
{
	size_t s;

	s = snprintf(buf, size, "%s%s%s%s%s", RESET, UEL, PJL_BEGIN_JOB, PJL_ENTER_LANG, RESET);
	memcpy(buf + s, pml, MIN(size - s, len));
	s += MIN(size - s, len);
	s += snprintf(buf + s, size - s, "%s%s%s%s", RESET, PJL_END_JOB, RESET, UEL);
	return s;
}

size_t pcl_buildPCLCmd(char *buf, size_t size, char punc, char letter1, char letter2, const char *data, size_t len, int value)
{
	size_t s;

	if (data == NULL) {
		s = snprintf(buf, size, "%s%c%c%d%c", ESC, punc, letter1, value, letter2);
	} else {
		s = snprintf(buf, size, "%s%c%c%u%c", ESC, punc, letter1, len, letter2);
		memcpy(buf + s, data, MIN(size - s, len));
		s += MIN(size - s, len);
	}
	return s;
}
