/*
 * This file is part of hp-utils.
 * Copyright (C) 2008 Michael Denk
 *
 * hp-utils is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * hp-utils is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with hp-utils; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Author: Michael Denk
 */

#ifndef PMLFAX_H_
#define PMLFAX_H_ 1

#include "device.h"

/* fax-types */
#define FAX_TYPE_NONE   0
#define FAX_TYPE_BLACK_SEND_EARLY_OPEN   1 /* newer models */
#define FAX_TYPE_BLACK_SEND_LATE_OPEN   2 /* older models */
#define FAX_TYPE_BLACK_AND_COLOR_SEND   3 /* future */
#define FAX_TYPE_SOAP   4

int pmlfax_setDateAndTime(struct device *d);
int pmlfax_getPhoneNum(struct device *d, char *out, size_t size);
int pmlfax_setPhoneNum(struct device *d, const char *s);
int pmlfax_getStationName(struct device *d, char *out, size_t size);
int pmlfax_setStationName(struct device *d, const char *s);

#endif /* PMLFAX_H_ */
