/*
 * Collection of utility functions and macros
 * Copyright (c) 2008 Michael Denk <code@michaeldenk.de>
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef UTIL_H_
#define UTIL_H_ 1

#include <stdlib.h>

#ifndef EXTRA_VERSION
#define EXTRA_VERSION
#endif

#define print_version() puts(SELF " " VERSION EXTRA_VERSION)
#define print_copy_msg() fprintf(stderr, SELF "  Copyright (C) 2008  Michael Denk\n" \
		"This program comes with ABSOLUTELY NO WARRANTY.\n" \
		"This is free software, and you are welcome to redistribute it\n" \
		 "under certain conditions; see COPYING file for more details.\n\n")
#define my_free(x) free(x); (x) = NULL;
#define MIN(a, b)	((a)<(b)?(a):(b))
#define MAX(a, b)	((a)>(b)?(a):(b))

char * strip(char *s);
char * replace(char *str, char from, char to);
int bool(unsigned long int i);
void * my_malloc(size_t size);
void * my_calloc(size_t num, size_t size);
void helpinfo(const char *pname, const char *fmt, ...);

#endif /* UTIL_H_ */
